package org.springblade.person.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.person.entity.Psychiatric;
import org.springblade.person.vo.PsychiatricVO;
import org.springblade.person.wrapper.PsychiatricWrapper;
import org.springblade.person.service.IPsychiatricService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-28
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/psychiatric")

public class PsychiatricClient implements IPsychiatricClient {

    private final IPsychiatricService psychiatricService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public PsychiatricVO detail(@SpringQueryMap Psychiatric psychiatric) {
        Psychiatric detail = psychiatricService.getOne(Condition.getQueryWrapper(psychiatric));
        return PsychiatricWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<PsychiatricVO> list(Psychiatric psychiatric) {
        return PsychiatricWrapper.build().listVO(psychiatricService.list(Condition.getQueryWrapper(psychiatric)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Psychiatric psychiatric) {
        return psychiatricService.save(psychiatric);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Psychiatric psychiatric) {
        return psychiatricService.updateById(psychiatric);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Psychiatric psychiatric) {
        return psychiatricService.saveOrUpdate(psychiatric);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return psychiatricService.deleteLogic(Func.toLongList(ids));
        }


}
